﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IGDocumentation
{
    public class CarsBusinessLogic
    {
        public ObservableCollection<Car> GetCars()
        {
            ObservableCollection<Car> carList = new ObservableCollection<Car>();
            carList.Add(new Car("Dodge", "Ram", true, false));
            carList.Add(new Car("Ford", "Explorer", false, true));
            carList.Add(new Car("BMW", "Z4", true, false));
            carList.Add(new Car("Toyota", "Camry", false, true));
            carList.Add(new Car("Dodge", "Ram", true, false));
            carList.Add(new Car("Ford", "Explorer", true, false));
            carList.Add(new Car("BMW", "Z4", false, true));
            carList.Add(new Car("Toyota", "Camry", true, false));
         

            return carList;
        }
    }

    public class Car : INotifyPropertyChanged
    {
        string m_make;
        string m_model;
        bool m_baseprice;
        bool m_mileage;

        public Car()
        {
        }

        public Car(string make, string model, bool baseprice, bool mileage)
        {
            this.Make = make;
            this.Model = model;
            this.BasePrice = baseprice;
            this.Mileage = mileage;
        }

        public string Make
        {
            get { return m_make; }
            set
            {
                if (m_make != value)
                {
                    m_make = value;
                    OnPropertyChanged("Make");
                }
            }
        }

        public string Model
        {
            get { return m_model; }
            set
            {
                if (m_model != value)
                {
                    m_model = value;
                    OnPropertyChanged("Model");
                }
            }
        }

        public bool BasePrice
        {
            get { return m_baseprice; }
            set
            {
                if (m_baseprice != value)
                {
                    m_baseprice = value;
                    OnPropertyChanged("BasePrice");
                }
            }
        }

        public bool Mileage
        {
            get { return m_mileage; }
            set
            {
                if (m_mileage != value)
                {
                    m_mileage = value;
                    OnPropertyChanged("Mileage");
                }
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }

}